unit JumpFlyForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,StdCtrls,F8OpenGL,F8GLUtils, Vcl.ExtCtrls,PluginCore;

type
  TForm1 = class(TForm)
    XPosition: TEdit;
    YPosition: TEdit;
    ZPosition: TEdit;
    YAngle: TEdit;
    PAngle: TEdit;
    RAngle: TEdit;
    StartButton: TButton;
    Label1: TLabel;
    Label2: TLabel;
    FirstSpeedEdit: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    AirResistanceEdit: TEdit;
    Label5: TLabel;
    GravitEdit: TEdit;
    RadioGroup1: TRadioGroup;
    JumpType: TRadioButton;
    FlyType: TRadioButton;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    SpeedEdit: TEdit;
    AccEdit: TEdit;
    ResultEdit: TEdit;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    StopButtion: TButton;
    Label6: TLabel;
    PersonType1Edit: TEdit;
    PersonType2Edit: TEdit;
    Label16: TLabel;
    StartModelNameEdit: TEdit;
    Label17: TLabel;
    Label18: TLabel;
    FinModelNameEdit: TEdit;
    ChangePersonXEdit: TEdit;
    ChangePersonYEdit: TEdit;
    ChangePersonZEdit: TEdit;
    ChangeCameraEyeXEdit: TEdit;
    ChangeCameraEyeYEdit: TEdit;
    ChangeCameraEyeZEdit: TEdit;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    GameFPSEdit: TEdit;
    Label28: TLabel;
    Label29: TLabel;
    MidModelEdit: TEdit;
    AddMidButton: TButton;
    ReadyButton: TButton;
    Label30: TLabel;
    ViewEdit: TEdit;


    procedure FormShow(Sender: TObject);
    procedure StartButtonClick(Sender: TObject);
    procedure StopButtionClick(Sender: TObject);
    procedure MoveWithPerson;
    procedure Label23Click(Sender: TObject);
    procedure EditChange(Sender:TObject);
    procedure weatherfin(point:GLPointType);
    procedure JumpTypeClick(Sender: TObject);
    procedure FlyTypeClick(Sender: TObject);
    procedure fpsChange(Sender:TObject);
    procedure ReadyButtonClick(Sender: TObject);
    procedure AddMidButtonClick(Sender: TObject);
    procedure DelMidButtonClick(Sender: TObject);
  private
    { Private declarations }
    p_userSet : Boolean;
    p_eyePoint : GLPointType;
    p_viewPointPoint : GLPointType;
    p_rollAngle : Double;
    p_updatingControls : Boolean;
    p_fps:integer;
    p_setview:Boolean;


    procedure onDestroy(Sender: TObject); overload;
    //Keyboard callbacks
    procedure MainKeyUp(sender: TObject; var key: Word; shift: TShiftState);
    procedure MainKeyDown(sender: TObject; var key: Word; shift: TShiftState);
    function ConvertToAngles(eye, view : GLPointType) : GLPointType;
    function ConvertToViewPoint(eye, angles : GLPointType) : GLPointType;

    function CheckAngleToSpeed(angles:IF8ModelInstance) : GLPointType;
    function CheckName(modelname:string):IF8ModelInstance;
  public
    p_gameState : integer;
      p_gameMode : integer;
  //    p_gamelock : Boolean;
    { Public declarations }
    procedure SetupCamera;
//    procedure MoveCamera;
    function getcurrentYangle:Double;
    function getcurrentviewangle:double;

  end;

PersonModel=class
  public
  PersonUnit:IF8ModelInstance;
  P_Current_Speed:GLPointType;
  P_Current_Acc:GLPointType;
  P_Type:integer;
end;


JFModel=class
  ModelUnit:IF8ModelInstance;
  Model_Angle:GLPointType;
  Start_Speed:GLPointType;
end;

var
  Form1: TForm1;
  person1:PersonModel;
  person2:PersonModel;
  startModel:JFModel;
  finModel:JFModel;
  midModel:Array[0..20] of JFModel;
  AirResistance:Double;
  Gravit:Double;

  myThread:TThread;
  p_firsttime : Boolean;
  p_survive : Boolean;


  fps:integer;
  ready:Boolean;
  viewAngle:Double;
 // terrain:IF8Terrain;

  f_up:Boolean;
  f_down:Boolean;
  f_left:Boolean;
  f_right:Boolean;
implementation

{$R *.dfm}
 uses
 Math,
 JumpFlyMain;
{ TForm1 }

//==============================================================================
//  change to person2
//==============================================================================
procedure ChangeOneToTwo;
var
speed:GLPointType;
position: GLPointType;
acc:GLPointType;
begin
//form1.p_gamelock:=false;
form1.p_gamestate:=2;
speed[_x]:=person1.P_Current_Speed[_x];
speed[_y]:=person1.P_Current_Speed[_y];
speed[_z]:=person1.P_Current_Speed[_z];
person2.P_Current_Speed:=speed;
position[_x]:=person1.PersonUnit.position[_x];
position[_y]:=person1.PersonUnit.position[_y];
position[_z]:=person1.PersonUnit.position[_z];
person2.PersonUnit.instancePosition:=position;
acc[_x]:=person1.P_Current_Acc[_x];
acc[_y]:=person1.P_Current_Acc[_y];
acc[_z]:=person1.P_Current_Acc[_z];
person2.P_Current_Acc:=acc;
position[_x]:=0;
position[_y]:=0;
position[_z]:=0;
speed[_x]:=0;
speed[_y]:=0;
speed[_z]:=0;
acc[_x]:=0;
acc[_y]:=0;
acc[_z]:=0;
person1.P_Current_Speed:=speed;
person1.P_Current_Acc:=acc;
person1.PersonUnit.instancePosition:=position;
//form1.p_gamelock:=true;
end;
//==============================================================================
//  change back to person1
//==============================================================================
procedure ChangeTwoToOne;
var
speed:GLPointType;
position: GLPointType;
acc:GLPointType;
begin
form1.p_gamestate:=1;
speed[_x]:=person2.P_Current_Speed[_x];
speed[_y]:=person2.P_Current_Speed[_y];
speed[_z]:=person2.P_Current_Speed[_z];
person1.P_Current_Speed:=speed;
position[_x]:=person2.PersonUnit.position[_x];
position[_y]:=person2.PersonUnit.position[_y];
position[_z]:=person2.PersonUnit.position[_z];
person1.PersonUnit.instancePosition:=position;
acc[_x]:=person2.P_Current_Acc[_x];
acc[_y]:=person2.P_Current_Acc[_y];
acc[_z]:=person2.P_Current_Acc[_z];
person1.P_Current_Acc:=acc;
position[_x]:=0;
position[_y]:=0;
position[_z]:=0;
speed[_x]:=0;
speed[_y]:=0;
speed[_z]:=0;
acc[_x]:=0;
acc[_y]:=0;
acc[_z]:=0;
person2.P_Current_Speed:=speed;
person2.P_Current_Acc:=acc;
person2.PersonUnit.instancePosition:=position;
end;


//==============================================================================
//  Get Current Acc
//==============================================================================
function GetCurrentAcc(person:PersonModel):GLPointType;
var
newPoint:GLPointType;
aForceAcc:GLPointType;
frontbackacc:double;
leftrightacc:double;
angle:double;
begin
  angle:=Form1.getcurrentYangle();
  aForceAcc[_x]:=-AirResistance*person.P_Current_Speed[_x]*20/500;
  aForceAcc[_y]:=-AirResistance*person.P_Current_Speed[_y]*20/500;
  aForceAcc[_z]:=-AirResistance*person.P_Current_Speed[_z]*20/500;
  frontbackacc:=0;
  leftrightacc:=0;
  if f_down then
  frontbackacc:=-2;
  if f_up then
  frontbackacc:=2;
  if f_right then
  leftrightacc:=-2;
  if f_left then
  leftrightacc:=2;

  newPoint[_y]:=-Gravit+aForceAcc[_y];
  if form1.p_gameState=2 then
  newPoint[_y]:=-1+aForceAcc[_y]*3;
//  newPoint[_x]:=aForceAcc[_x]+leftrightacc*cos(angle)+frontbackacc*sin(angle);
//  newPoint[_z]:=aForceAcc[_z]+frontbackacc*cos(angle)-leftrightacc*sin(angle);
  newPoint[_x]:=aForceAcc[_x]+leftrightacc;
  newPoint[_z]:=aForceAcc[_z]+frontbackacc;
  person.PersonUnit.yawAngle:=(angle+form1.getcurrentviewangle)*PI/180;
  result:= newPoint;
end;







//function GetCurrentPosition(point : GLPointType):GLPointType;
//var
//newPoint:GLPointType;
//begin
//
//  result:= newPoint;
//end;


procedure TForm1.weatherfin(point:GLPointType);
var
high:double;
f_coll:Boolean;
begin
high:= APlugin.winRoadApplication.project.GetActualHeightAt(point[_x],point[_z]);
if (point[_y]<high) and (point[_y] > 0.0) then
begin
p_survive:=false;
ResultEdit.Text:='You Dead';
end;
//  if p_gamelock then
 // begin
    if p_gamestate=1 then
        begin
        f_coll:=true;
        if person1.PersonUnit.position[_x]<>finmodel.ModelUnit.position[_x] then
        f_coll:=false;
        if(person1.PersonUnit.position[_y]-finmodel.ModelUnit.position[_y])>abs(person1.P_Current_Speed[_y])/p_fps*3 then
        f_coll:=false;
        if person1.PersonUnit.position[_z]<>finmodel.ModelUnit.position[_z] then
        f_coll:=false;
        if person1.PersonUnit.CollisionWith(finmodel.ModelUnit,false) or f_coll then
          begin
          p_survive:=false;
          resultEdit.text:='You Win';
          end;
        end;
    if p_gamestate=2 then
        begin
        f_coll:=true;
        if person2.PersonUnit.position[_x]<>finmodel.ModelUnit.position[_x] then
       f_coll:=false;
        if(person2.PersonUnit.position[_y]-finmodel.ModelUnit.position[_y])>abs(person2.P_Current_Speed[_y])/p_fps*3 then
        f_coll:=false;
        if person2.PersonUnit.position[_z]<>finmodel.ModelUnit.position[_z] then
        f_coll:=false;
        if person2.PersonUnit.CollisionWith(finmodel.ModelUnit,false) or f_coll then
          begin
          p_survive:=false;
          if StrToFloatDef(SpeedEdit.Text,0)>60.0 then
          resultEdit.Text:='Too fast! You Dead '
          else
          resultEdit.text:='You Win';
          end;
        end;
 //   end;
end;
//==============================================================================
//  Initialisation of the form when it is shown.
//==============================================================================


procedure TForm1.FormShow(Sender: TObject);
 var
        method : TMethod;
//        i:integer;
        f_jump:Boolean;
    begin
    myThread:=TThread.CreateAnonymousThread(
    procedure
      var
      i:integer;
      newpoint : GLPOINTTYPE;
      newspeed : GLPointType;
      f_coll:Boolean;
      j:integer;
      begin
      f_jump:=false;
      i:=1;
        while true do
          begin
          if p_survive then
            begin
            if p_gamestate = 1  then
             begin
                    person1.P_Current_Acc:=GetCurrentAcc(person1);
                    newspeed[_x]:=person1.P_Current_Speed[_x]+person1.P_Current_Acc[_x]/p_fps*3;
                    if p_gamemode=1 then
                        begin
                        for j := 0 to 20 do
                        begin
                          if midModel[j]<>nil then
                          begin
                          f_coll:=true;
                          if person1.PersonUnit.position[_x]<>midModel[j].ModelUnit.position[_x] then
                          f_coll:=false;
                          if(person1.PersonUnit.position[_y]-midModel[j].ModelUnit.position[_y])>abs(person1.P_Current_Speed[_y])/p_fps*3 then
                          f_coll:=false;
                          if person1.PersonUnit.position[_z]<>midModel[j].ModelUnit.position[_z] then
                          f_coll:=false;
                            if person1.PersonUnit.CollisionWith(midModel[j].ModelUnit,false) or
                             f_coll then
                             f_jump:=true;
                          end;
                        end;
                        if f_jump then
                        begin
                        newspeed[_y]:=abs(person1.P_Current_Speed[_y])+person1.P_Current_Acc[_y]/p_fps*3;
                        f_jump:=false;
                        end
                        else
                        begin
                        newspeed[_y]:=person1.P_Current_Speed[_y]+person1.P_Current_Acc[_y]/p_fps*3;
                        end;
                        end;
                    if p_gamemode=2 then
                    begin
                    newspeed[_y]:=person1.P_Current_Speed[_y]+person1.P_Current_Acc[_y]/p_fps*3;
                    end;
                    newspeed[_z]:=person1.P_Current_Speed[_z]+person1.P_Current_Acc[_z]/p_fps*3;
                    person1.P_Current_Speed := newspeed ;
                    newpoint[_x]:= person1.PersonUnit.instancePosition[_x]+person1.P_Current_Speed[_x]/p_fps*3;
                    newpoint[_y]:= person1.PersonUnit.instancePosition[_y]+person1.P_Current_Speed[_y]/p_fps*3;
                    newpoint[_z]:= person1.PersonUnit.instancePosition[_z]+person1.P_Current_Speed[_z]/p_fps*3;
                    person1.PersonUnit.instancePosition:=newpoint;
                    MoveWithPerson();
        //            SpeedEdit.Text := FloatToStr(sqrt(sqr(person1.P_Current_Speed[_x])+sqr(person1.P_Current_Speed[_y])+sqr(person1.P_Current_Speed[_z])));
                    SpeedEdit.Text := FloatToStr(person1.P_Current_Speed[_y]);
                    AccEdit.Text := FloatToStr(sqrt(sqr(person1.P_Current_Acc[_x])+sqr(person1.P_Current_Acc[_y])+sqr(person1.P_Current_Acc[_z])));
                    weatherfin(person1.PersonUnit.instancePosition);
             end;
             if p_gamestate=2 then
                   begin
                     person2.P_Current_Acc:=GetCurrentAcc(person2);
                    newspeed[_x]:=person2.P_Current_Speed[_x]+person2.P_Current_Acc[_x]/p_fps*3;
                    newspeed[_y]:=person2.P_Current_Speed[_y]+person2.P_Current_Acc[_y]/p_fps*3;
                    newspeed[_z]:=person2.P_Current_Speed[_z]+person2.P_Current_Acc[_z]/p_fps*3;
                    person2.P_Current_Speed := newspeed ;
                    newpoint[_x]:= person2.PersonUnit.instancePosition[_x]+person2.P_Current_Speed[_x]/p_fps*3;
                    newpoint[_y]:= person2.PersonUnit.instancePosition[_y]+person2.P_Current_Speed[_y]/p_fps*3;
                    newpoint[_z]:= person2.PersonUnit.instancePosition[_z]+person2.P_Current_Speed[_z]/p_fps*3;
                    person2.PersonUnit.instancePosition:=newpoint;
                    MoveWithPerson();
                    SpeedEdit.Text := FloatToStr(sqrt(sqr(person2.P_Current_Speed[_x])+sqr(person2.P_Current_Speed[_y])+sqr(person2.P_Current_Speed[_z])));
                 // SpeedEdit.Text := FloatToStr(person2.P_Current_Speed[_y]);
                    AccEdit.Text := FloatToStr(sqrt(sqr(person2.P_Current_Acc[_x])+sqr(person2.P_Current_Acc[_y])+sqr(person2.P_Current_Acc[_z])));
                    weatherfin(person2.PersonUnit.instancePosition);
                   end;


//            if i<1000 then begin
//              i:=i+1;
//            end
//            else begin
//              p_survive := false;
//            end;
            end;
          sleep(fps);
          end;
      end
    );
//    p_gamelock:=true;
    p_firsttime := true;
    p_survive:=false;
    p_rollAngle := 0;
    p_updatingControls := true;
    p_userSet := false;
    p_gameMode:=1;
    p_fps:=25;
    p_setview:=true;
    fps:=Trunc(1000/p_fps);
    f_up:=false;
    f_down:=false;
    f_left:=false;
    f_right:=false;
  //  UpdateCameraList;
    APlugin.winRoadApplication.mainForm.StartSimulation;
//    terrain := APlugin.winRoadApplication.project.GetTerrain;
    startButton.Enabled:=false;
    AddMidButton.Enabled:=true;
 //   DelMidButton.Enabled:=true;
    ChangePersonXEdit.Enabled:=false;
    ChangePersonYEdit.Enabled:=false;
    ChangePersonZEdit.Enabled:=false;
    ChangeCameraEyeXEdit.Enabled:=false;
    ChangeCameraEyeYEdit.Enabled:=false;
    ChangeCameraEyeZEdit.Enabled:=false;
    viewEdit.Enabled:=false;
     FormMainKeyUpDownProc(method) := MainKeyUp;
    APlugin.winRoadApplication.RegisterEventHandler( _plgFormMainKeyUp, method);
    //Registers key down event
    FormMainKeyUpDownProc(method) := MainKeyDown;
    APlugin.winRoadApplication.RegisterEventHandler( _plgFormMainKeyDown, method);
    end;
procedure TForm1.fpsChange(Sender: TObject);
begin
p_fps:= StrToIntDef(GameFPSEdit.Text,50);
end;

function TForm1.getcurrentviewangle: double;
begin
result:=StrToFloatDef(viewEdit.text,0);
end;

function TForm1.getcurrentYangle: Double;
begin
result:= StrToFloatDef(YAngle.Text,0);
end;

procedure TForm1.FlyTypeClick(Sender: TObject);
begin
AddMidButton.Enabled:=false;
//DelMidButton.Enabled:=false;
personType2Edit.Enabled:=true;
p_gameMode:=2;
end;

procedure TForm1.JumpTypeClick(Sender: TObject);
begin
AddMidButton.Enabled:=true;
//DelMidButton.Enabled:=true;
personType2Edit.Enabled:=false;
p_gameMode:=1;
end;

procedure TForm1.Label23Click(Sender: TObject);
begin

end;

//procedure TForm1.MoveCamera;
//begin
//    APlugin.winRoadApplication.mainForm.openGL.Camera.Eye.X := startModel.ModelUnit.position[_x]-10;
//    APlugin.winRoadApplication.mainForm.openGL.Camera.Eye.Y := startModel.ModelUnit.position[_y]+50;
//    APlugin.winRoadApplication.mainForm.openGL.Camera.Eye.Z := startModel.ModelUnit.position[_z];
//    APlugin.winRoadApplication.mainForm.openGL.Camera.ViewPoint.X :=startModel.ModelUnit.position[_x];
//    APlugin.winRoadApplication.mainForm.openGL.Camera.ViewPoint.Y :=startModel.ModelUnit.position[_y];
//    APlugin.winRoadApplication.mainForm.openGL.Camera.ViewPoint.Z :=startModel.ModelUnit.position[_z];
//end;

//==============================================================================
//  change the angle to speed (test value)
//==============================================================================


function TForm1.CheckAngleToSpeed(angles:IF8ModelInstance): GLPointType;
begin
result[_x] := -sin(angles.rollAngle * PI / 180);
result[_y] := cos(angles.rollAngle * PI / 180) * cos(-angles.pitchAngle * PI / 180);
result[_z] := cos(angles.rollAngle * PI / 180) * sin(-angles.pitchAngle * PI / 180);
end;
//==============================================================================
//  find model
//==============================================================================
function TForm1.CheckName(modelname:string): IF8ModelInstance;
var
project: IF8ProjectForRoad;
i:integer;
begin
project :=APlugin.winRoadApplication.project;
   i := 1;

   while assigned(project.modelInstance[i]) do
   begin
     if project.modelInstance[i].name=modelname then
     begin
     result:=project.modelInstance[i];
//     result.instancePosition:=result.position;
     Exit;
     end;
     i:=i+1;
   end;
   ShowMessage('error! please check Model name');
end;

function TForm1.ConvertToAngles(eye, view: GLPointType): GLPointType;
 var
          zero : GLPointType;
          vect : GLPointType;
    begin
    result[_w] := 0; //not used
    result[_z] := 0; //Roll angle always zero in standard camera of UC-win/Road

    //Calculates the yaw angle from the vector
    //zero = vector with Yaw Angle = 0
    zero[_x] := 0;
    zero[_y] := 0;
    zero[_z] := 1;
    vect := F8Difference(view, eye);
    vect[_y] := 0;
    vect := F8Normalize(vect);
    result[_x] := ArcCos(F8DotProduct(vect, zero)); //Yaw angle
    //0---> X
    //|
    //|
    //V  Z
    if vect[_x] < 0 then //Sets the sign of the angle
        result[_x] := -result[_x];

    //Pitch angle
    result[_y] := -ArcSin(F8Normalize(F8Difference(view, eye))[_y]);
    end;

function TForm1.ConvertToViewPoint(eye, angles: GLPointType): GLPointType;
    begin
    //Set view point with 0,0,0 angles
    result := eye;
    result[_z] := result[_z] + 2; //Target point should be 2m away from the eye.

    //Rotates the view point according to the Yaw and Pitch angles (Roll = 0)
    result := F8RotateAbout(result, eye, AsGLPointType(1,0,0), angles[_y]);
    result := F8RotateAbout(result, eye, AsGLPointType(0,1,0), angles[_x]);
    end;

//==============================================================================
//keyboard
//==============================================================================

procedure TForm1.MainKeyDown(sender: TObject; var key: Word;  shift: TShiftState);
begin
  if key = 87 then
  begin
  f_up:=true;
  end;
  if key = 83 then
  begin
  f_down:=true;
  end;
  if key = 65 then
  begin
  f_left:=true;
  end;
  if key = 68 then
  begin
  f_right:=true;
  end;
   if key = 69 then
  begin
  changeOneToTwo;
  end;
end;

procedure TForm1.MainKeyUp(sender: TObject; var key: Word; shift: TShiftState);
begin
  if key = 87 then
  begin
  f_up:=false;
  end;
  if key = 83 then
  begin
  f_down:=false;
  end;
  if key = 65 then
  begin
  f_left:=false;
  end;
  if key = 68 then
  begin
  f_right:=false;
  end;

end;
//==============================================================================
//Takes the value of the edit boxes and apply the parameters to the main
//camera of UC-win/Road.
//==============================================================================
procedure TForm1.MoveWithPerson;
   var
        angles : GLPointType;
        yaw : Double;
        pitch : Double;

    begin
    //Does not update the camera while updating the controls
    if p_updatingControls then
        Exit;
    //Get camera parameters from the controls
    if p_gamemode=1 then
          begin
          p_eyePoint[_x] := person1.PersonUnit.instancePosition[_x]+StrToFloatDef(ChangeCameraEyeXEdit.Text,0);
          p_eyePoint[_y] := person1.PersonUnit.instancePosition[_y]+StrToFloatDef(ChangeCameraEyeYEdit.Text,1);
          p_eyePoint[_z] := person1.PersonUnit.instancePosition[_z]+StrToFloatDef(ChangeCameraEyeZEdit.Text,0);
          if TryStrToFloat(YAngle.Text, yaw) and
             TryStrToFloat(PAngle.Text, pitch) then
              begin
              //Convert angle data to eye point
              angles[_x] := yaw * PI / 180;
              angles[_y] := pitch * Pi / 180;
              angles[_z] := 0;
              p_viewPointPoint := ConvertToViewPoint(p_eyePoint, angles);
              //Set flag to true in order to update the camera when UC-win/Road requires it.
              p_userSet := true;
              end;
          p_rollAngle := StrToFloatDef(RAngle.Text, p_rollAngle);
          F8RotateAbout(person1.PersonUnit.instancePosition,person1.PersonUnit.instancePosition,AsGLPointType(0,1,0),angles[_x]+ StrToFloatDef(viewEdit.Text,0));
          end;
    if p_gamemode=2 then
    begin
      if p_gamestate=2 then
      begin
          p_eyePoint[_x] := person2.PersonUnit.instancePosition[_x]+StrToFloatDef(ChangeCameraEyeXEdit.Text,0);
          p_eyePoint[_y] := person2.PersonUnit.instancePosition[_y]+StrToFloatDef(ChangeCameraEyeYEdit.Text,1);
          p_eyePoint[_z] := person2.PersonUnit.instancePosition[_z]+StrToFloatDef(ChangeCameraEyeZEdit.Text,0);
          if TryStrToFloat(YAngle.Text, yaw) and
             TryStrToFloat(PAngle.Text, pitch) then
              begin
              //Convert angle data to eye point
              angles[_x] := yaw * PI / 180;
              angles[_y] := pitch * Pi / 180;
              angles[_z] := 0;
              p_viewPointPoint := ConvertToViewPoint(p_eyePoint, angles);
              //Set flag to true in order to update the camera when UC-win/Road requires it.
              p_userSet := true;
              end;
          p_rollAngle := StrToFloatDef(RAngle.Text, p_rollAngle);
          F8RotateAbout(person2.PersonUnit.instancePosition,person2.PersonUnit.instancePosition,AsGLPointType(0,1,0),angles[_x]+ StrToFloatDef(viewEdit.Text,0));
      end;
      if p_gamestate=1 then
      begin
          p_eyePoint[_x] := person1.PersonUnit.instancePosition[_x]+StrToFloatDef(ChangeCameraEyeXEdit.Text,0);
          p_eyePoint[_y] := person1.PersonUnit.instancePosition[_y]+StrToFloatDef(ChangeCameraEyeYEdit.Text,1);
          p_eyePoint[_z] := person1.PersonUnit.instancePosition[_z]+StrToFloatDef(ChangeCameraEyeZEdit.Text,0);
          if TryStrToFloat(YAngle.Text, yaw) and
             TryStrToFloat(PAngle.Text, pitch) then
              begin
              //Convert angle data to eye point
              angles[_x] := yaw * PI / 180;
              angles[_y] := pitch * Pi / 180;
              angles[_z] := 0;
              p_viewPointPoint := ConvertToViewPoint(p_eyePoint, angles);
              //Set flag to true in order to update the camera when UC-win/Road requires it.
              p_userSet := true;
              end;
          p_rollAngle := StrToFloatDef(RAngle.Text, p_rollAngle);
          F8RotateAbout(person1.PersonUnit.instancePosition,person1.PersonUnit.instancePosition,AsGLPointType(0,1,0),angles[_x]+ StrToFloatDef(viewEdit.Text,0));
      end;
    end;

    setupCamera;
    end;


procedure TForm1.EditChange(Sender: TObject);
    var
        point:GLPointType;
    begin
    //Does not update the camera while updating the controls
     point[_x]:=startmodel.ModelUnit.instancePosition[_x]+ StrToFloatDef(ChangePersonXEdit.Text,0);
        point[_y]:=startmodel.ModelUnit.instancePosition[_y]+ StrToFloatDef(ChangePersonYEdit.Text,1);
        point[_z]:=startmodel.ModelUnit.instancePosition[_z]+ StrToFloatDef(ChangePersonZEdit.Text,0);
    if p_setview then
    begin
    if p_gamemode=1 then
    begin

        p_eyePoint[_x] := person1.PersonUnit.instancePosition[_x]+StrToFloatDef(ChangeCameraEyeXEdit.Text,10);
        p_eyePoint[_y] := person1.PersonUnit.instancePosition[_y]+StrToFloatDef(ChangeCameraEyeYEdit.Text,10);
        p_eyePoint[_z] := person1.PersonUnit.instancePosition[_z]+StrToFloatDef(ChangeCameraEyeZEdit.Text,0);
        person1.PersonUnit.instancePosition:=point;
    end;
    if p_gamemode=2 then
    begin
        point[_x]:=startmodel.ModelUnit.instancePosition[_x]+ StrToFloatDef(ChangePersonXEdit.Text,0);
        point[_y]:=startmodel.ModelUnit.instancePosition[_y]+ StrToFloatDef(ChangePersonYEdit.Text,1);
        point[_z]:=startmodel.ModelUnit.instancePosition[_z]+ StrToFloatDef(ChangePersonZEdit.Text,0);
        if p_gamestate=1 then
        begin
          p_eyePoint[_x] := person1.PersonUnit.instancePosition[_x]+StrToFloatDef(ChangeCameraEyeXEdit.Text,10);
          p_eyePoint[_y] := person1.PersonUnit.instancePosition[_y]+StrToFloatDef(ChangeCameraEyeYEdit.Text,10);
          p_eyePoint[_z] := person1.PersonUnit.instancePosition[_z]+StrToFloatDef(ChangeCameraEyeZEdit.Text,0);
          person1.PersonUnit.instancePosition:=point;
        end;
        if p_gamestate=2 then
        begin
          p_eyePoint[_x] := person2.PersonUnit.instancePosition[_x]+StrToFloatDef(ChangeCameraEyeXEdit.Text,10);
          p_eyePoint[_y] := person2.PersonUnit.instancePosition[_y]+StrToFloatDef(ChangeCameraEyeYEdit.Text,10);
          p_eyePoint[_z] := person2.PersonUnit.instancePosition[_z]+StrToFloatDef(ChangeCameraEyeZEdit.Text,0);
          person2.PersonUnit.instancePosition:=point;
        end;
    end;
    p_userSet := true;
    SetUpCamera;
    end;
    end;


//==============================================================================
//  move the camera
//==============================================================================
procedure TForm1.SetupCamera;
var
angles:GLPointType;
begin
p_updatingControls := true;
APlugin.winRoadApplication.mainForm.openGL.CameraTilt := p_rollAngle;
if p_userSet then
  begin
    p_userSet := false;
    APlugin.winRoadApplication.mainForm.openGL.Camera.Eye.X := p_eyePoint[_x];
    APlugin.winRoadApplication.mainForm.openGL.Camera.Eye.Y := p_eyePoint[_y];
    APlugin.winRoadApplication.mainForm.openGL.Camera.Eye.Z := p_eyePoint[_z];
    APlugin.winRoadApplication.mainForm.openGL.Camera.ViewPoint.X :=p_viewPointPoint[_x];
    APlugin.winRoadApplication.mainForm.openGL.Camera.ViewPoint.Y :=p_viewPointPoint[_y];
    APlugin.winRoadApplication.mainForm.openGL.Camera.ViewPoint.Z :=p_viewPointPoint[_z];
  end
else
  begin
    p_eyePoint := APlugin.winRoadApplication.mainForm.openGL.Camera.Eye.point;
    p_viewPointPoint := APlugin.winRoadApplication.mainForm.openGL.Camera.ViewPoint.point;
    if not XPosition.Focused then
      XPosition.Text := FloatToStr(p_eyePoint[_x]);
    if not XPosition.Focused then
      YPosition.Text := FloatToStr(p_eyePoint[_y]);
    if not XPosition.Focused then
      ZPosition.Text := FloatToStr(p_eyePoint[_z]);
    angles := ConvertToAngles(p_eyePoint, p_viewPointPoint);
    if not YAngle.Focused then
      YAngle.Text := Format('%.0f', [angles[_x]* 180 / PI]);
    if not PAngle.Focused then
      PAngle.Text := Format('%.0f', [angles[_y]* 180 / PI]);
    if not RAngle.Focused then
    begin
      p_rollAngle := APlugin.winRoadApplication.mainForm.openGL.cameraTilt;
      RAngle.Text := Format('%.0f', [p_rollAngle]);
    end;
  end;
p_updatingControls := false;
end;

//==============================================================================
//  prepare the game
//==============================================================================
procedure TForm1.ReadyButtonClick(Sender: TObject);
var
sacc:GLPointType;
begin
ready:=true;
    viewEdit.Enabled:=true;
    ChangePersonXEdit.Enabled:=true;
    ChangePersonYEdit.Enabled:=true;
    ChangePersonZEdit.Enabled:=true;
    ChangeCameraEyeXEdit.Enabled:=true;
    ChangeCameraEyeYEdit.Enabled:=true;
    ChangeCameraEyeZEdit.Enabled:=true;
    person1.PersonUnit:=CheckName(PersonType1Edit.Text);
    if person1.PersonUnit=nil then
    begin
      ready:=false;
      showMessage('person1 error ');
    end;
    if p_gameMode=2 then
      begin
      person2.PersonUnit:=CheckName(PersonType2Edit.Text);
      if person2.PersonUnit=nil then
         begin
         ready:=false;
         showMessage('person2 error ');
         end;
      end;
    startModel.ModelUnit:=CheckName(StartModelNameEdit.Text);
    if startModel.ModelUnit=nil then
    begin
      ready:=false;
      showMessage('startModel error ');
    end;
    finModel.ModelUnit:=CheckName(FinModelNameEdit.Text);
    if finModel.ModelUnit=nil then
    begin
      ready:=false;
      showMessage('finModel error ');
    end;
    if trim(FirstSpeedEdit.Text)='' then
    begin
    showMessage('firstSpeed can not be empty');
    ready:=false;
    end;
    if (p_gamemode = 1) and
    (( StrToFloatDef( FirstSpeedEdit.Text , 1) < 1 )or ( StrToFloatDef ( FirstSpeedEdit.Text , 100 ) > 100 )) then
    begin
    showMessage('please input FirstSpeed between 1 to 100');
    ready:=false;
    end;
    if (p_gamemode = 2) and
    ((StrToFloatDef(FirstSpeedEdit.Text,1000)<1000 )or (StrToFloatDef(FirstSpeedEdit.Text,6000)>6000)) then
    begin
    showMessage('please input FirstSpeed between 1000 to 6000');
    ready:=false;
    end;
    if trim(AirResistanceEdit.Text)='' then
    begin
    showMessage('AirResistance can not be empty');
    ready:=false;
    end;
    if ((StrToFloatDef(AirResistanceEdit.Text,0)<0 )or (StrToFloatDef(AirResistanceEdit.Text,1)>1)) then
    begin
    showMessage('please input AirResistance between 0 to 1');
    ready:=false;
    end;
    if trim(GravitEdit.Text)='' then
    begin
    showMessage('Gravit can not be empty');
    ready:=false;
    end;
    if ((StrToFloatDef(GravitEdit.Text,0)<0 )or (StrToFloatDef(GravitEdit.Text,20)>20)) then
    begin
    showMessage('please input GravitEdit between 0 to 20');
    ready:=false;
    end;
    if ready and (p_gamemode=2)then
      begin
      StartButton.Enabled:=true;
      sacc[_x]:=startmodel.ModelUnit.position[_x];
      sacc[_y]:=StrToFloatDef(FirstSpeedEdit.Text,5000);
      sacc[_z]:=startmodel.ModelUnit.position[_z];
      startmodel.ModelUnit.instancePosition:=sacc;
      p_gamestate:=1;
      end;
    if ready and (p_gamemode=1)then
      begin
      StartButton.Enabled:=true;
//      sacc[_x]:=startmodel.ModelUnit.position[_x];
//      sacc[_y]:=StrToFloatDef(FirstSpeedEdit.Text,5000);
//      sacc[_z]:=startmodel.ModelUnit.position[_z];
//      startmodel.ModelUnit.instancePosition:=sacc;
//      p_gamestate:=1;
      end;
end;


//==============================================================================
//  Add mid Model
//==============================================================================
procedure TForm1.AddMidButtonClick(Sender: TObject);
var
i: integer ;
P_stopadd:Boolean;
p_success:Boolean;
n:integer;
name:string;
begin
//  i:=0;
  n:=0;
  p_success:=false;
  p_stopadd:=false;
  name:=MidModelEdit.Text;
  for i := 0 to 20 do
  begin
    if midModel[i]<>nil then
    begin
    n:=n+1;
    end;
  end;
  if n= 21 then
       P_stopadd:=true;
  if P_stopadd then
  begin
    ShowMessage('full! you can not add more unless delete one model');
    Exit;
  end;
  for i := 0 to 20 do
  begin
    if midModel[i]=nil then
    begin
    midModel[i]:=JFModel.Create;
    midModel[i].ModelUnit:=checkname(name);
    p_success:=true;
    break;
    end;
  end;
  if p_success then
  begin
    ShowMessage('add success!');
  end;

end;
//==============================================================================
//  Del mid Model
//==============================================================================
procedure TForm1.DelMidButtonClick(Sender: TObject);
var
i:integer;
name:string;
p_fail:Boolean;
begin
p_fail:=true;
name:=MidModelEdit.Text;
 for i := 0 to 20 do
  begin
  if midModel[i]<>nil then
   begin
     if midModel[i].ModelUnit.name= name then
     begin
       midModel[i].ModelUnit:=nil;
       midModel[i].Free;
       p_fail:=false;
       ShowMessage('delete success!');
     end;
   end;

  end;
  if p_fail then
  showMessage('can not find model in mid model list, make sure you add it');

end;
//==============================================================================
//  Start the game
//==============================================================================
procedure TForm1.StartButtonClick(Sender: TObject);
var
//point:GLPointType;
pspeed:GLPointType;
pacc:GLPointType;
sacc:GLPointType;
cspeed:GLPointType;
per2:GLPointType;
begin

if ready then
    begin
    resultEdit.text:='';
    fps:=Trunc(1000/p_fps);
    Gravit:= StrToFloatDef(GravitEdit.Text,Gravit);
        AirResistance:= StrToFloatDef(AirResistanceEdit.Text,AirResistance);
        if P_gameMode=1 then
        begin
        p_gamestate:=1;
        //startModel.Start_Speed:=CheckAngleToSpeed(startModel.ModelUnit);
        cspeed:=checkAngletoSpeed(startmodel.ModelUnit);
        pspeed[_x]:=StrToFloatDef(FirstSpeedEdit.Text,0)*cspeed[_x];
        pspeed[_y]:=StrToFloatDef(FirstSpeedEdit.Text,80)*cspeed[_y];
        pspeed[_z]:=StrToFloatDef(FirstSpeedEdit.Text,0)*cspeed[_z];
        sacc[_x]:=startModel.Model_Angle[_x];
        sacc[_y]:=startModel.Model_Angle[_y];
        sacc[_z]:=startModel.Model_Angle[_z];
        pacc[_x]:=0+sacc[_x];
        pacc[_y]:=-Gravit+sacc[_y];
        pacc[_z]:=0+sacc[_z];
        person1.P_Current_Acc:=pacc;
        person1.P_Current_Speed:=pspeed;
        person1.P_Type:=1;
//        person1.PersonUnit.instancePosition:=startModel.ModelUnit.instancePosition;
//        point[_x]:= startModel.ModelUnit.instancePosition[_x];
//        point[_y]:= startModel.ModelUnit.instancePosition[_y]+5;
//        point[_z]:= startModel.ModelUnit.instancePosition[_z];
//        person1.PersonUnit.instancePosition:=point;
        MoveWithPerson();
        p_survive:=true;
        if p_firsttime then
            begin
              myThread.Start;
              p_firsttime:=false;
            end
            else begin
              myThread.Resume;
            end;
        StartButton.Enabled:=false;
        p_setview:=false;
        end
    else if P_gameMode=2 then
        begin
        p_gamestate:=1;
        per2[_x]:=0;
        per2[_y]:=0;
        per2[_z]:=0;
        person2.PersonUnit.instancePosition:=per2;
        person2.P_Current_Speed:=per2;
        person2.P_Current_Acc:=per2;
        cspeed[_x]:=0;
        cspeed[_y]:=0;
        cspeed[_z]:=0;
        pacc[_x]:=0;
        pacc[_y]:=-Gravit;
        pacc[_z]:=0;
        person1.P_Current_Acc:=pacc;
        person1.P_Current_Speed:=cspeed;

        sacc[_x]:=startmodel.ModelUnit.position[_x];
        sacc[_y]:=StrToFloatDef(FirstSpeedEdit.Text,5000);
        sacc[_z]:=startmodel.ModelUnit.position[_z];
        startmodel.ModelUnit.instancePosition:=sacc;
        person1.PersonUnit.instancePosition:=sacc;

        MoveWithPerson();

         p_survive:=true;
        if p_firsttime then
            begin
              myThread.Start;
              p_firsttime:=false;
            end
            else begin
//            changeTwoToone;
              myThread.Resume;
            end;
        StartButton.Enabled:=false;
        p_setview:=false;
        end
    else
        begin
          ShowMessage('error game mode');
          exit;
        end;
    end;
end;




procedure TForm1.StopButtionClick(Sender: TObject);
begin
p_survive:=true;
person1.PersonUnit.instancePosition:=startModel.ModelUnit.instancePosition;
StartButton.Enabled:=true;
myThread.Suspend;
p_gamestate:=1;
end;

procedure TForm1.onDestroy(Sender: TObject);
 var
        method : TMethod;
begin
 //Unregisters keyboard event callbacks
    FormMainKeyUpDownProc(method) := MainKeyUp;
    APlugin.winRoadApplication.UnRegisterEventHandler( _plgFormMainKeyUp, method);
    FormMainKeyUpDownProc(method) := MainKeyDown;
    APlugin.winRoadApplication.UnRegisterEventHandler( _plgFormMainKeyDown, method);
end;
{ PersonModel }



initialization
begin
  person1 := PersonModel.create();
  person2 := PersonModel.create();
  startModel := JFModel.Create();
  finModel :=JFModel.Create();
end;

finalization
begin
   myThread.Terminate;
   startModel.Free;
   person1.free;
   person2.Free;
   finModel.Free;
end;


end.
