unit JumpFlyMain;

interface

uses
   Windows,
   Messages,
   SysUtils,
   Classes,
   Dialogs,
   Forms,
   PluginCore,
   Menus;


Type
JumpFlyMainClass=Class(TF8PluginClass,IF8OpenGLPlugin)
//procedure LEDSetClick(Sender: TObject);
  Strict private
  { Private declarations }
        p_winRoadApplication : IF8ApplicationServices;
      //Menu items added to the tools menu of UC-win/Road
        p_dashMenuItem : TMenuItem;
        p_JumpSetMenuItem : TMenuItem;
     //Interface in OpenGL
        procedure PaintScene;
        procedure PaintHUD;
        procedure SetupCamera;
   //Required function of a plug-in
        procedure JumpSetMenuClick(sender : TObject);
        procedure AbleMenus(enable : Boolean);
        procedure ProjectDestroyProc;
        procedure RemoveForms;
  public
  { Public declarations }

      procedure AfterConstruction; override;
      procedure BeforeDestruction; override;

      property winRoadApplication : IF8ApplicationServices read p_winRoadApplication;
End;
//Call back functions
procedure RegisterUserPlugin(out optionName, apiVersion, Copyright : String);
procedure LoadPlugin;
procedure UnloadPlugin;

var

    APlugin : JumpFlyMainClass;

implementation

uses
JumpFlyForm;
{ JumpFlyMainClass }
//==============================================================================
//  Called by UC-win/Road to enable menus.
//==============================================================================
procedure JumpFlyMainClass.AbleMenus(enable: Boolean);
begin
p_JumpSetMenuItem.Enabled := enable;
end;

procedure JumpFlyMainClass.AfterConstruction;
var
method:TMethod;
begin
  inherited;
  //gets the entry point of UC-win/Road
  Supports(ApplicationServices,IF8ApplicationServices,p_winRoadApplication);

  //Adds menu item for log demo
  p_JumpSetMenuItem := TMenuItem.Create(nil);
  p_JumpSetMenuItem.Name := 'JumpFlySet';
  p_JumpSetMenuItem.Caption := 'SetJump...';
  p_JumpSetMenuItem.OnClick := jumpSetMenuClick;
  p_winRoadApplication.mainForm.toolsMenu.Insert(0,p_JumpSetMenuItem);

  //Adds dash bar
  p_dashMenuItem := TMenuItem.Create(nil);
  p_dashMenuItem.Caption := cLineCaption;
  p_winRoadApplication.mainForm.toolsMenu.Insert(0, p_dashMenuItem);

  PluginNotifyProc(method):= ProjectDestroyProc;
  p_winRoadApplication.RegisterEventHandler(_plgProjectDestroy,method);

  PluginAbleMenusProc(method) := AbleMenus;
  p_winRoadApplication.RegisterEventHandler(_plgPluginAbleMenus, method);
end;

procedure JumpFlyMainClass.BeforeDestruction;
var
method : TMethod;
begin
  inherited;
  RemoveForms;
  p_winRoadApplication.mainForm.toolsMenu.Remove(p_JumpSetMenuItem);
  p_JumpSetMenuItem.Free;
  p_winRoadApplication.mainForm.toolsMenu.Remove(p_dashMenuItem);
  p_dashMenuItem.Free;

  PluginNotifyProc(method):= ProjectDestroyProc;
  p_winRoadApplication.UnRegisterEventHandler(_plgProjectDestroy,method);

  PluginAbleMenusProc(method):= AbleMenus;
  p_winRoadApplication.UnRegisterEventHandler(_plgPluginAbleMenus,method);

  //Release the entry point to UC-win/Road.
  p_winRoadApplication := nil;
end;

procedure JumpFlyMainClass.JumpSetMenuClick(sender: TObject);
begin
if not Assigned(Form1) then
Application.CreateForm(TForm1,Form1);
Form1.Show;
end;

procedure JumpFlyMainClass.ProjectDestroyProc;
begin
  RemoveForms;
end;

procedure JumpFlyMainClass.RemoveForms;
begin
if Assigned(Form1) then
  FreeAndNil(Form1);
end;

//==============================================================================
//   Registers the plugin
//==============================================================================
procedure RegisterUserPlugin(out optionName, apiVersion, Copyright : String);
    begin
    optionName := 'JumpFly Plugin';
    apiVersion := PLUGIN_VERSION;
   	Copyright := 'FORUM8 Co., Ltd.';
    end;

procedure LoadPlugin;
    begin
    if not Assigned(APlugin) then
        APlugin := JumpFlyMainClass.Create;
    if Assigned(APlugin) and Assigned(APlugin.winRoadApplication) then
        APlugin.winRoadApplication.RegisterPluginObject(APlugin);

    end;

procedure UnloadPlugin;
    begin
    // Free the plugin
     if Assigned(APlugin) and Assigned(APlugin.winRoadApplication) then
        APlugin.winRoadApplication.UnRegisterPluginObject(APlugin);
    APlugin.Free;
    APlugin := nil;
    end;

//==============================================================================
//  Implementation of the PaintHUD function of IF8OpenGLPlugin
//  Does nothing in that sample
//==============================================================================
procedure JumpFlyMainClass.PaintHUD;
    begin
    end;

//==============================================================================
//  Implementation of the PaintScene function of IF8OpenGLPlugin
//  Does nothing in that sample
//==============================================================================
procedure JumpFlyMainClass.PaintScene;
    begin
    end;
//==============================================================================
//  Implementation of the SetupCamera function of IF8OpenGLPlugin
//  This function is called by UC-win/Road to allow a plugin to control the
//  position of the main camera. This function is called for each frame drawn in
//  main view of UC-win/Road. If the position of the camera is not overwritten,
//  the camera moves accordingly to the standard features of UC-win/Road.
//==============================================================================
procedure JumpFlyMainClass.SetupCamera;
    begin
    if Assigned(Form1) then
        Form1.SetupCamera;
    end;
end.
